# (c) Copyright 2001-2002 WildWizard.
# ⥫쭠 ଠ  http://taplap.ru

# Hydra -  ⥬  ᠭ IF   Python.
# ᭮  PAWS (Roger Plowman).

# The source code is solely for educational purposes, it may not be changed
# and redistributed by anyone but the author. 
#  室 ⥪ 㦨 ⮫쪮 ࠧ⥫ 楫,
#   ࠭   ࠢ ⮫쪮 .


import types
import sys

_VERSION = '0.3 public beta'

GENERAL = 'General'
PICKABLE = 'Pickable'
SUPPORTER = 'Supporter'
CONTAINER = 'Container'
OPENABLE = 'Openable'
OPEN = 'Open'
HIDE = 'Hide'
SWITCHABLE = 'Switchable'
ON = 'On'
CLOTHING = 'Clothing'
WORN = 'Worn'

TRUE = -1
FALSE = 0

#     " ", " "...
IT = 0
THEM = 1
HIM = 2
HER = 3

I = 1
WE = 2
YOU = 3
YOUS = 4
HE = 5
SHE = 6
IT = 7
THEY = 8

PLURAL = 9

#  :
ALLOW_NO_DOBJS = 1          # Allow No Direct Objects
ALLOW_NO_IOBJS = 2          # Allow No Indirect Objects
ALLOW_ONE_DOBJ = 4          # Allow 1 Direct Object
ALLOW_ONE_IOBJ = 8          # Allow 1 Indirect Object
ALLOW_MULTIPLE_DOBJS = 16   # Allow Multiple Direct Objects
ALLOW_MULTIPLE_IOBJS = 32   # Allow Multiple Indirect Objects
ALLOW_OPTIONAL_DOBJS = 64   # Allow Optional Direct Objects

def AppendDictList(Dict,Key,Value):
	"""塞 祭  ᫮ """
	#WordList = string.split(string.lower(Key),",")
	WordList = Key.lower().split(",")
	for word in WordList:
		if Dict.has_key(word):
			Dict[word].append(Value)
		else:
			Dict[word] = [Value]

class cl_global:
	def __init__(self):
		#'': [SmallRock]
		self.NounsDict = {}
		#'ᬮ': [LookVerb, LookIntoVerb, LookUnderVerb]
		self.VerbsDict = {}
		#'让': [Troll, Diamond]
		self.AdjsDict = {}
		#'': [LookUnderVerb]
		self.PrepsDict = {}
		
		self.Debug = FALSE
		
		self.InputPrompt='\n> '

		# ᯨ᮪  ꥪ⮢  ⮤ found_in
		self.FoundInList=[]
		
		# ப
		self.Player = None

		# ண   ⨯ " ", " ".
		self.PronounsListDict = {"": IT, "": THEM, "": THEM, "":HIM, "":HER, "": HER}
		self.PronounsDict = {IT: None, THEM: [], HIM: None, HER: None}

		# "   "
		self.ConjunctionsList = ["",","]

		# "   謠"
		self.DisjunctionsList = ["஬"]

		# " .    ⮫"
		self.CommandBreaksList = ["⥬", ".", "?", "!"]

		# ⠩
		self.Timers = {}
		
		# ப,  짮⥫ 㤥 ࠧ    Input  뢠   [['','',''],['','']]
		self.CommandsList = []
		
		#  䠩  ன  ७
		self.GameModule = "temp"
		
		#  ப 
		self.InputString = ""
		
		#  ࠧࠥ   
		self.ActiveCommandList = []
		
		# ", 쬨   ⮫"
		self.CurActor = None	# goblin
		self.CurVerb = None		# take
		self.CurDObj = []		# book
		self.CurPrep = []		# from
		self.CurIObj = []		# table
		self.CurText = ""
		
		self.PrevVerb = None	# ।.  ( "᭮")
		self.Again = None		#   ᠬ  "᭮"
		
		self.IO = None
		
		self.Save = None
		self.Restore = None

Global = cl_global()

# ᮪饭  IO -
def say(text):
	#TODO: 믮塞 ࠦ  {} ???  . ⥬  直???
#	if "{" in text and "}" in text: # ᫨   ᪮
#	    OpenBrace  = text.find("{")
#	    CloseBrace = text.find("}")
#	    Global.IO.say(text[:OpenBrace]) #  ᪮
#	    try:
#	        Expr = eval(text[OpenBrace+1:CloseBrace]) # ᪮
#	        if type(Expr) == type(""): say(Expr)
#	    except:
#	        say("Invalid CBE '%s'" % text[OpenBrace+1:CloseBrace])
#	    say(text[CloseBrace+1:])
#	else:
#		Global.IO.say(text)
	Global.IO.say(text)
def more():
	Global.IO.more()
def finsay():
	Global.IO.finsay()
def cap():
	Global.IO.cap()
def Say(text):
	"""⠢ 䫠, ⮡ ࢠ 㪢 뫠   뢠 say(text)"""
	cap()
	say(text)

def HandlePunctuation(WordList):
	"""室  ९    ⤥묨 ᫮"""

	Punctuation = ':;!.,?"'

	for Word in WordList[:]:
		if Word[-1] in Punctuation:
			Item = WordList.index(Word)
			WordList.insert(Item+1,Word[-1])
			WordList[Item] = Word[:-1]
	return WordList

def GetPlayerInput():
	""" """
	Global.InputString = Global.IO.input(Global.InputPrompt)
	ParsePlayerInput()

def ParsePlayerInput():
	"""।⥫ ࠧ """

	#   窠 뢠  CurText  १ 
	Global.CurText = "" #  ப  ६ ࠭ אַ ⥪
	c1 = Global.InputString.find('"') # 饬  
	c2 = Global.InputString.find('"',c1+1) # - 
	if c1 != -1 and c2 != -1: # ᫨ 諨  窨
		Global.CurText = Global.InputString[c1+1:c2] #  ⥪
		Global.InputString = Global.InputString[:c1] + Global.InputString[c2+1:] # १ 

	TempWordList = Global.InputString.split() # ࠧ  ᫮
	
	TempWordList = HandlePunctuation(TempWordList) # ⤥塞  ९  ⤥ ᫮
	
	for word in TempWordList[:]:
		if word in Global.CommandBreaksList: # ᫨ ᫮ ࠧ⥫
			Item = TempWordList.index(word) #  
			Global.CommandsList.append(TempWordList[:Item]) # 뢠  ᯨ᮪   ᫮ ࠧ⥫
			TempWordList = TempWordList[Item+1:] # ⠢塞 ⮪
	else:
		Global.CommandsList.append(TempWordList)
	if Global.CommandsList[-1] == []:
		Global.CommandsList = Global.CommandsList[:-1]

def PreParser():
	LastWord = len(Global.ActiveCommandList) - 1
	CurrentWord = 0
	while CurrentWord <= LastWord:
		#Word = string.lower(Global.ActiveCommandList[CurrentWord]) #TODO:  ᪮ ⮦
		Word = Global.ActiveCommandList[CurrentWord].lower()
		if not InVocabulary(Word) and Word[0]<>"{": # { -   ⮬.
			#   ᪥ - "릭*"
			is_ok=FALSE
			tempword=Word
			while len(tempword)>1 and not is_ok:
				tempword=tempword+"*"
				if InVocabulary(tempword):
					Word=tempword
					is_ok=TRUE
					#break
				tempword=tempword[:len(tempword)-2] # 㡨ࠥ *  ᫥ ᨬ
			if not is_ok:
				return Error(ParserError.NotInVocabulary % Word)
		Global.ActiveCommandList[CurrentWord] = Word
		CurrentWord = CurrentWord + 1
	return TRUE

def AddTimer(timer,time):
	"""  - ⠩"""
	time=abs(time)
	Global.Timers[timer] = [time,time]
	return TRUE

def DelTimer(timer):
	""" -  ᯨ᪠ ⠩஢"""
	if not Global.Timers.has_key(timer): return FALSE
	del Global.Timers[timer]
	return TRUE
	
def DoTimers():
	"""ࠡ뢠/᪠ - ⠩"""
	for timer in Global.Timers.keys(): #   ⠩
		Global.Timers[timer][0]-=1 # 㬥蠥  ६
		if Global.Timers[timer][0] == 0: #  ᫨  ⥪...
			ret = run(timer) # ...᪠ 
			if not ret: # ᫨ 㦭 㤠
				DelTimer(timer) #TODO:  㢥७,   ࠢ쭮, ..  ࠡ⠥  ⨬ ᫮६
			else:
				Global.Timers[timer][0]=Global.Timers[timer][1] # ⠢ ⠩  砫쭮 祭

def DoFoundIn():
	"""६頥 ꥪ  ᢮⢮ found_in"""
	tomove = FALSE
	for item in Global.FoundInList: # ॡࠥ  ।  Global.FoundInList
		# found_in   ⠭⮩ TRUE  FALSE, -, ᯨ᪮ 権,  樥
		if type(item._found_in) in [types.FunctionType, types.MethodType]: # -
			tomove = item._found_in(Player().Location) # 뢠 -, । ࠬ -  ப
		elif type(item._found_in) == types.IntType: # TRUE  FALSE
			tomove = item._found_in
		elif type(item._found_in) in [types.TupleType, types.ListType]: # ᯨ᮪ 権
			if Player().Location in item._found_in: # ⥪   ᯨ᪥
				tomove = TRUE
		else: #  
			if Player().Location == item._found_in:
				tomove = TRUE
		if tomove:
			move(item,Player().Location)
		else:
			move(item,None)

def DoEachTurn(inobj):
	"""each_turn 樨  ﬨ"""
	run(inobj,"each_turn")
	for obj in inobj.Contents:
		run(obj,"each_turn")
		if hasattr(obj,"Supporter") or hasattr(obj,"Container"):
			DoEachTurn(obj)

def Parser():
	"""ࠡ⪠ """
	Global.ActiveCommandList = Global.CommandsList[0] # ६ ࠧࠥ 
	del Global.CommandsList[0] # 㤠塞   . ᯨ᪠
	
	if not PreParser(): return FALSE # ।⥫쭠 ࠡ⪠
	
	#   :
	# ,   쬨             ⮫
	#CurActor CurVerb  CurDObj CurPrep  CurIObj
	#John     TakeVerb Book    FromPrep Table

	# 饬 
	PotentialVerbList = []
	for word in Global.ActiveCommandList:
		if Global.VerbsDict.has_key(word):
			#Global.CurrentVerbNoun = word
			VerbLocation = Global.ActiveCommandList.index(word)
			PotentialVerbList = Union(PotentialVerbList,Global.VerbsDict[word])
			break
	else:
		return Error(ParserError.NoVerb)
	Global.CurPrep = []
	PrepositionList = []
	FirstPrepLocation = VerbLocation
	if len(Global.ActiveCommandList) > 1:
		for word in Global.ActiveCommandList[VerbLocation + 1:]:
			if Global.PrepsDict.has_key(word):
				Global.CurPrep.append(word)
				PrepositionList = Union(PrepositionList,Global.PrepsDict[word])
				if FirstPrepLocation == VerbLocation:
					FirstPrepLocation = Global.ActiveCommandList.index(word)
	if len(PrepositionList) == 0:
		PrepositionList = Union(PrepositionList,Global.PrepsDict["nopreposition"])
	PotentialVerbList = Intersect(PotentialVerbList,PrepositionList)
	if len(PotentialVerbList) == 0 and VerbLocation == FirstPrepLocation:
		return Error(ParserError.NoPreposition)
	if len(PotentialVerbList) == 0 and VerbLocation < FirstPrepLocation:
		return Error(ParserError.NoSuchVerbPreposition)
	if len(PotentialVerbList) > 1:
		return Error(ParserError.MultipleVerbPrepositions)
	Global.CurVerb = PotentialVerbList[0] # 諨 !!!!

	#   "᭮"
	if Global.CurVerb == Global.Again and Global.Again <> None:
		if Global.PrevVerb == None: return Error(ParserError.NoPreviousCommand)
		Global.CurVerb = Global.PrevVerb
		return TRUE

	#    ।騩
	Global.PrevVerb = Global.CurVerb
	
	# ⥯ 饬 CurActor
	Global.CurActor = Global.Player
	if VerbLocation > 0:
		Global.CurActor = ParserIdentifyNoun(0,VerbLocation)
		Global.CurActor = Global.CurActor[0]
		Global.CurActor = Global.CurActor[0]

		if type(Global.CurActor) == type([]):
			Global.CurActor = Global.Player
			return Error(ParserError.MultipleActors)
	
	######################
	# ᪮ 몥 , 騥 inderect objects ᥣ  ।.
	# ᪮ , ⮬  ⠪: (᫥   १ ࠧ⥫, ⥬  㥬)
	if VerbLocation+1 != len(Global.ActiveCommandList) and not Global.PrepsDict.has_key(Global.ActiveCommandList[FirstPrepLocation]):
		for word in Global.ActiveCommandList[VerbLocation+1:len(Global.ActiveCommandList)-1]:
			# ᫨   ᫮,  Word in Global.ConjunctionsList,  index ࢮ   ⠭ FirstPrepLocation
			nextword=Global.ActiveCommandList[Global.ActiveCommandList.index(word)+1]
			if not(word in Global.ConjunctionsList) and not(nextword in Global.ConjunctionsList):
				Global.ActiveCommandList.insert(Global.ActiveCommandList.index(nextword),",")
				FirstPrepLocation=Global.ActiveCommandList.index(nextword)-1
				break
	######################

	# 饬 CurDObj
	Global.CurDObj = []
	if len(Global.ActiveCommandList) > 1:
		Global.CurDObj = ParserIdentifyNoun(VerbLocation,FirstPrepLocation)
	# 饬 CurIObj
	Global.CurIObj = []
	if len(Global.ActiveCommandList) > FirstPrepLocation + 1:
		Global.CurIObj = ParserIdentifyNoun(FirstPrepLocation + 1,len(Global.ActiveCommandList) + 1)
	# "ᬮ  㭤" - 㭤   DObj   IObj
	if (FirstPrepLocation - VerbLocation) <= 1:
		Global.CurDObj = Global.CurIObj[:]
		Global.CurIObj = []
	
	# 饬 , , ...
	if len(Global.CurDObj) == 0:
		for word in Global.ActiveCommandList:
			if word in Global.PronounsListDict.keys():
				if len(Global.PronounsDict[Global.PronounsListDict[word]]) > 0:
					Global.CurDObj.append(Union(Global.CurDObj,Global.PronounsDict[Global.PronounsListDict[word]]))
	return TRUE

def Error(text):
	""" 訡(?)"""
	say(text)
	return FALSE
	
class parsererror_cl:
	def __init__(self):
		self.NoVerb = " ⮬ ।  ."
		self.NoPreposition = " ⮣  ॡ ।."
		self.NoPreviousCommand = " 祣  뫮 ᤥ!"
		self.NoSuchVerbPreposition = "       ।."
		self.MultipleVerbPrepositions = "訡  ணࠬ:          ।."
		self.MultipleActors = " ࠧ  ਪ뢠 ⮫쪮  ."
		self.DObjsNotAllowed = "    ⭮  -  ꥪ⠬."
		self.IObjsNotAllowed = "    ⭮  -  ꥪ⠬."
		self.NeedDObj = "筨."
		self.NeedIObj = "筨."
		self.MultipleDObjsNotAllowed = "   ᯮ짮  ᪮쪨 ।⠬ ࠧ."
		self.MultipleIObjsNotAllowed = "   ᯮ짮  ᪮쪨 ।⠬ ࠧ."
		self.NotInVocabulary = "   ᫮ '%s'."
		self.TooManyVariants = "᪮쪮 ਠ⮢ - 筨 ."

ParserError = parsererror_cl();

def InVocabulary(Word):
	if Global.NounsDict.has_key(Word): return TRUE
	if Global.VerbsDict.has_key(Word): return TRUE
	if Global.AdjsDict.has_key(Word): return TRUE
	if Global.PrepsDict.has_key(Word): return TRUE
	if Global.PronounsListDict.has_key(Word): return TRUE
	#if Word in Global.ArticlesList: return TRUE
	if Word in Global.ConjunctionsList: return TRUE
	if Word in Global.DisjunctionsList: return TRUE
	if Word in Global.CommandBreaksList: return TRUE
	return FALSE

def ParserIdentifyNoun(StartPos,EndPos):
	"""Returns a list of objects identified by nouns in Global.ActiveCommandList """
	AdjectiveList = []
	NounList = []
	ReturnList = []
	for word in Global.ActiveCommandList[StartPos:EndPos]:
		if Global.AdjsDict.has_key(word):
			AdjectiveList = Union(AdjectiveList,Global.AdjsDict[word])
			DebugTrace(word + " is Adjective")
		if Global.NounsDict.has_key(word):
			DebugTrace(word + " is Noun")
			NounList = Union(NounList,Global.NounsDict[word])
			if len(AdjectiveList) > 0:
				NounList = Intersect(NounList,AdjectiveList)
			ReturnList.append(NounList)
			AdjectiveList = []
			NounList = []
	return ReturnList

def Intersect(list1,list2):
	"""Returns intersection of two lists"""
	ReturnList = []

	for x in list1:
		if x in list2: ReturnList.append(x)

	return ReturnList

def Union(list1,list2):
    """Returns union of two lists"""
    ReturnList = list1[:]
    for x in list2:
        if not x in ReturnList: ReturnList.append(x)
    return ReturnList

def DeleteDictList(Dictionary,Object=None):
	"""Delete Object From Dictionary List"""
	if Object == None: return
	if len(Dictionary) == 0: return
	for key in Dictionary.keys():
		List = Dictionary[key]
		if type(List) <> type([]): continue
		if Object in List:
			List.remove(Object)
			if len(List) == 0:
				del Dictionary[key]
			else:
				Dictionary[key] = List

def DeleteObjectFromVocabulary(Object):
	"""Deletes Passed Object From All Vocabulary Dictionaries"""
	DeleteDictList(Global.VerbsDict,Object)
	DeleteDictList(Global.PrepsDict,Object)
	DeleteDictList(Global.NounsDict,Object)
	DeleteDictList(Global.AdjsDict,Object)

def DebugTrace(Text):
	if not Global.Debug: return
	print Text

def PreParse(sstr):
	return FALSE #  த ?

def run(obj,func):
	"""᫨  obj  ਡ func, : ᫨ func ப - ⠥ , ᫨ ⮤  - - ᪠  頥 饭 祭."""
	if not hasattr(obj,func):
		return FALSE
	oo=getattr(obj,func)
	if type(oo) == types.StringType:
		say(oo)
		return TRUE
	elif type(oo) == types.MethodType or type(oo) == types.FunctionType:
		ret=oo()
		return ret
	elif type(oo) == types.IntType:
		if oo == TRUE:
			return TRUE
	return FALSE

def here(obj, actor):
	"""஢, 室  ꥪ  ⮩  ,   ."""
	if actor.Location == obj: # ᫨  
		return TRUE
	if isin(actor.Location,obj): # ᫨   
		return TRUE
	if isin(actor,obj): #  
		return TRUE
	return FALSE

def isin(obj2,obj):
	"""஢, 室  ꥪ  Contents obj2  ⮬ ."""
	if inlist(obj2.Contents,obj):
		return TRUE
	for o in obj2.Contents:
		if (hasattr(o,"Container") or hasattr(o,"Supporter")) and (not hasattr(o,"Openable") or hasattr(o,"Open")):
			if isin(o,obj):
				return TRUE
	return FALSE

def inlist(list,obj):
	"""஢, 室  ꥪ  ᯨ᪥."""
	try:
		list.index(obj)
	except:
		return FALSE
	return TRUE

def give(obj,atr):
	setattr(obj,atr,TRUE)

def move(obj,where):
	try:
		obj.Location.Contents.remove(obj)
	except:
		pass #  ଠ쭮, ᫨  ᬮ  -    頥
	try:
		obj.Location=where
		if where != None:
			where.Contents.append(obj)
	except:
		return FALSE
	return TRUE

#  ᮪饭:
def Actor():
	return Global.CurActor
def Verb():
	return Global.CurVerb
def DObj():
	return Global.CurDObj
def Prep():
	return Global.CurPrep
def IObj():
	return Global.CurIObj
def Player():
	return Global.Player

def NoNone(obj):
	if type(obj) != types.NoneType:
		return TRUE
	return FALSE

##########################################################################################################
##########################################################################################################
##########################################################################################################
##########################################################################################################
##########################################################################################################
##########################################################################################################

# ᪮쪮 ᯮ㥬 ᫮   
CanWord={I:"", WE:"", YOU:"",YOUS:"", HE:"",SHE:"",IT:"",THEY:""}#,PLURAL:""}
GoWord={I:"襫", WE:"諨", YOU:"襫",YOUS:"諨", HE:"襫",SHE:"諠",IT:"諮",THEY:"諨"}#,PLURAL:"諨"}
GoInWord={I:"襫", WE:"諨", YOU:"襫",YOUS:"諨", HE:"襫",SHE:"諠",IT:"諮",THEY:"諨"}#,PLURAL:"諨"}
GoOutWord={I:"襫", WE:"諨", YOU:"襫",YOUS:"諨", HE:"襫",SHE:"諠",IT:"諮",THEY:"諨"}#,PLURAL:"諨"}

class fake_cl:
	pass

fake=fake_cl()

def DescribeLocation(actor):
	DoFoundIn() # ६頥 ꥪ  found_in #TODO: -    ࠢ쭮,  ࠧ      ⢨  ᫥, ⮡ ⠢ DoFoundIn   ᫨誮 
	say("<br>")
	say("<b>")
	cap()
	run(actor.Location,"SDesc")
	say("</b><br><br>")
	run(actor.Location,"LDesc")
	notfirst=FALSE
	say("<br>")
	for obj in actor.Location.Contents: # 뢮 ᠭ  Describe
		if not hasattr(obj,"Hide"):
			if run(obj,"Describe"):
				give(obj,"Workflag") #  Workflag, ⮡  뢮 ᠭ  饬 
				say("<br>")
	for obj in actor.Location.Contents: # 뢮 ᠭ  ꥪ⮢  .  describe,    Hide
		if not hasattr(obj,"Hide") and not hasattr(obj,"Workflag"):
			if notfirst:
				say(", ")
			else:
				say("   : ")
				notfirst=TRUE
			#run(obj,"SDesc")
			SDesc(obj)
		elif hasattr(obj,"Workflag"): # 㤠塞 Workflag'
			delattr(obj,"Workflag")
	if notfirst:
		say(".")

def ListContents(lobj,tab,hide=TRUE):
	"""⠥ ⨪  ᯨ᮪  ᮤন lobj"""
	for obj in lobj.Contents:
		f=0
		while f<tab:
			say("&nbsp;&nbsp;")
			f+=1
		if not hide or obj.hasnt(HIDE):
			SDesc(obj)
			say("<br>")
			if obj.has(SUPPORTER):
				ListContents(obj,tab+1)
			elif obj.has(CONTAINER):
				ListContents(obj,tab+1)

def SDesc(obj):
	if run(obj,"SDesc"): # 㫨  FALSE -   뫮 ࠡ⪨
		if obj.has(OPENABLE):
			if obj.has(OPEN):
				say(" (.)")
			else:
				say(" (.)")
		if obj.has(SWITCHABLE):
			if obj.has(ON):
				say(" (.)")
			else:
				say(" (몫.)")
		if obj.has(CLOTHING):
			if obj.has(WORN):
				say(" ()")

class game_cl:
	def __init__(self):
		self.Author = " "
		self.Copyright = "copyright"
		self.IntroText = "㯨⥫ ⥪"
		self.Name = " "
		self.Version = " "
		self.Encoding = "DOS"
		self.Running = TRUE
	def Banner(self):
		say('<p align="center"><b>'+self.Name+'</b> '+self.Version+' '+self.Copyright+'</p>')
		say('<p align="center">: '+self.Author+'</p>')
		say('<p align="center">Hydra '+_VERSION+'</p>')
		say('<p>'+self.IntroText+"</p>")
	def Turn(self):
		if not PreParse(Global.InputString): #  preparse
			if not Player().Location.PreParse(Global.InputString): # preparse  樨 ப
				if Parser(): # ࠧࠥ ப
					#  , , 
					# Global.PronounsDict[IT] = Global.PronounsDict[HIM] = Global.PronounsDict[HER] = None
					# Global.PronounsDict[THEM] = []
					if len(DObj()) == 1:
						Global.PronounsDict[IT] = Global.PronounsDict[HIM] = Global.PronounsDict[HER] = DObj()[0] # ..   ࠧ砥  ।⮢
						Global.PronounsDict[THEM] = []
					elif len(DObj()) > 0:
						Global.PronounsDict[THEM] = DObj()
						Global.PronounsDict[IT] = Global.PronounsDict[HIM] = Global.PronounsDict[HER] = None
					else:
						Global.PronounsDict[IT] = Global.PronounsDict[HIM] = Global.PronounsDict[HER] = None
						Global.PronounsDict[THEM] = []
					Verb()._Action() # ⢨ 
		Global.CommandsList=[]
		#DoFoundIn() # ६頥 ꥪ  found_in
		DoTimers() # ࠡ뢠 ⠩
		DoEachTurn(Global.Player.Location) # each_turn 樨
		DoEachTurn(Global.Player) # each_turn  ।⮢ 
		finsay() # 뢮  ⥪  ࠭
	def OnQuit(self):
		say('<p align="center"><b>ᨡ  .</b></p>')

Game = game_cl()

#  饩,   ஢
class baseobj_cl:
	def __init__(self):
		self.Location = None
		self.Contents = []
	def has(self,attr):
		if hasattr(self,attr):
			return TRUE
		return FALSE
	def hasnt(self,attr):
		if self.has(attr):
			return FALSE
		return TRUE
	def give(self,attr):
		give(self,attr)
	def take(self,attr):
		delattr(self,attr)
	def move(self,where):
		move(self,where)
	def isin(self,where):
		return isin(where,self)

class verb_cl:
	"""   """
	def __init__(self,name,oth,preps = "nopreposition"):
		AppendDictList(Global.VerbsDict,name,self)
		#AppendDictList(Global.VerbsDict,oth,self)
		AppendDictList(Global.PrepsDict,preps,self)
		
		templist = oth.lower().split(",")
		# ࠧ  
		self.PDict = {HE: None, SHE: None, IT: None, PLURAL: None} #  ᮢ襭   - "", "믠"...
		self.PDict[HE]=templist[0] #TODO ஢ઠ 訡 -    । 
		self.PDict[SHE]=templist[1]
		self.PDict[IT]=templist[2]
		self.PDict[PLURAL]=templist[3]
		
		self.ObjectAllowance = ALLOW_MULTIPLE_DOBJS + ALLOW_NO_IOBJS
	def Action(self,actor,verb,dobj,prep,iobj):
		say(" 祣  .")
		return FALSE
	def _Action(self):
		if len(DObj()) <> 0 and (self.ObjectAllowance & ALLOW_NO_DOBJS > 0):
			return Error(ParserError.DObjsNotAllowed)
		if len(IObj()) <> 0 and (self.ObjectAllowance & ALLOW_NO_IOBJS > 0):
			return Error(ParserError.IObjsNotAllowed)
		if len(DObj()) > 1 and (self.ObjectAllowance & ALLOW_ONE_DOBJ > 0):
			return Error(ParserError.MultipleDObjsNotAllowed)
		if len(IObj()) > 1 and (self.ObjectAllowance & ALLOW_ONE_IOBJ > 0):
			return Error(ParserError.MultipleIObjsNotAllowed)
		if len(DObj()) == 0 and (self.ObjectAllowance & ALLOW_NO_DOBJS == 0):
			return Error(ParserError.NeedDObj)
		if len(IObj()) == 0 and (self.ObjectAllowance & ALLOW_NO_IOBJS == 0):
			return Error(ParserError.NeedIObj)
		# ਪ뢠 , ண  :
		if Actor() != Player() and Actor().Location != Player().Location:
			say("  "+Actor().PDict[1]+".")
			return FALSE
		if Actor().Command(): # ⠥  ஬
			if Actor().Location.Ver(): #     ⮬ 
				if self.ObjectAllowance & ALLOW_NO_DOBJS > 0: # ⠪ 
					Global.CurDObj=[[fake]]
				if self.ObjectAllowance & ALLOW_NO_IOBJS > 0:
					Global.CurIObj=[[fake]]
				for dobj in DObj(): #   d-ꥪ
					if type(dobj) == types.ListType and len(dobj)>1: # ᪮쪮 ਠ⮢
						return Error(ParserError.TooManyVariants)
					for iobj in IObj(): #   i-ꥪ
						if type(iobj) == types.ListType and len(iobj)>1: # ᪮쪮 ਠ⮢
							return Error(ParserError.TooManyVariants)
						self.Action(Actor(),Verb(),dobj[0],Prep(),iobj[0])

class item_cl(baseobj_cl):
	"""   饩"""
	def __init__(self,oth,adjs=""):
		AppendDictList(Global.NounsDict,oth,self)
		AppendDictList(Global.AdjsDict,adjs,self)
		self.SDesc = oth.lower().split(",",1)[0]
		self.LDesc="祣 筮."
		#self.Form=HE # ⮣   ⠪ 㧪   
		baseobj_cl.__init__(self)
		
		#  ⢨⥫쭮
		self.PDict = oth.lower().split(",")
	def Command(self,who=Global.Player):
		say("  襢 ।⮬.")
		return FALSE
	def found_in(self,where):
		Global.FoundInList.append(self)
		self._found_in = where

class dir_cl:
	def __init__(self,name):
		AppendDictList(Global.NounsDict,name,self)
		self.name = name.lower().split(",",1)[0]

N = dir_cl("ᥢ,")
NE = dir_cl("ᥢ-⮪,")
E = dir_cl("⮪,")
SE = dir_cl("-⮪,")
S = dir_cl(",")
SW = dir_cl("-,")
W = dir_cl(",")
NW = dir_cl("ᥢ-,")
Up = dir_cl("")
Down = dir_cl("")
In = dir_cl("")
Out = dir_cl("")

class actor_cl(baseobj_cl):
	"""   ஢"""
	def __init__(self,oth,adjs=""):
		#AppendDictList(Global.NounsDict,name,self)
		AppendDictList(Global.NounsDict,oth,self)
		AppendDictList(Global.AdjsDict,adjs,self)
		self.Gender=HE #    PLURAL - . ᫮
		self.Form=HE # ଠ ⭮⥫쭮   ப - " ", " 襫"(ப).  ᮢ  .Gender  ப.   (?)
		self.SDesc = oth.lower().split(",",1)[0]
		self.LDesc="祣 筮."

		# 
		self.PDict = oth.lower().split(",")

		baseobj_cl.__init__(self)
	def Command(self,who=Global.Player):
		"""ப  ஬"""
		return TRUE
	def Move(self,direction,where,actor):
		""" """
		if type(where) == types.StringType:
			return say(where)
		elif type(where) in [types.FunctionType, types.MethodType]:
			return where()
		cap()
		run(actor,"SDesc")
		if direction==In:
			say(" "+GoInWord[self.Form]+".")
		elif direction==Out:
			say(" "+GoOutWord[self.Form]+".")
		else:
			say(" "+GoWord[self.Form]+"  "+direction.name+".")
		move(self,where)
		if Global.Player==actor: # ப ⮬᪨ ᬠਢ
			DescribeLocation(actor)
		return TRUE

class room_cl(baseobj_cl):
	"""   """
	def __init__(self,oth=None,adjs=""):
		if oth != None: #    易⥫쭮  ᫮ ᠭ
			AppendDictList(Global.NounsDict,oth,self)
			AppendDictList(Global.AdjsDict,adjs,self)
			self.SDesc = oth.lower().split(",",1)[0]
			#  ⢨⥫쭮
			self.PDict = oth.lower().split(",")
		else:
			self.SDesc = "⭮ "
		self.LDesc="祣 筮."
		baseobj_cl.__init__(self)

	def Ver(self):
		return TRUE
	def PreParse(self,sstr):
		return FALSE
	def dTakeBefore(self):
		cap()
		run(actor,"SDesc")
		say("  "+CanWord[actor.Form]+"  "+dobj.PDict[3]+".")
		return TRUE
	Map={}
	def BaseDir(self):
		"""⪠   ணࠬ஢ ࠢ."""
		cap()
		run(Actor(),"SDesc")
		say("  "+CanWord[Actor().Form]+" 㤠 .") # "   㤠 ."


# ꥪ ப  㬮砭
BaseMe=actor_cl(",⥡,⥡,⥡,⮡,⥡,ᥡ,")
BaseMe.SDesc=""
BaseMe.Gender=HE
BaseMe.Form=YOU
give(BaseMe,"Hide") # ⮡  ᠭ   뢠
Global.Player=BaseMe
